stages:
  - Tag
  - Prepare
  - Build
  - Release

.frontend_job_variables:
  variables:
    BACKEND_PATH: 'frontend-mono'

# ------ Generic jobs ------
frontend:Tag latest container when there are no changes:
  extends:
    - .frontend_job_variables
    - .tag_latest_backend_container_template
  # only is used to add this job only when the app or ci template is NOT changed
  # This is not supported yet by rules
  only:
    variables:
      - $CI_COMMIT_TAG =~ /^release\//
      - $CI_COMMIT_BRANCH =~ /^(master|production|preprod|development)$/
  except:
    refs:
      - schedule
      - web
    changes:
      - 'frontend-mono/**/*'
      - 'template.gitlab-ci.yml'

frontend:Prepare App bundles:
  stage: Prepare
  image: node:lts
  tags: ['xxllnc-shared']
  extends:
    - .frontend_job_variables
  needs: ['wait-for-other-pipelines-to-finish']
  rules:
    - if: $CI_PIPELINE_SOURCE == "schedule"
      when: never
    - if: '$CI_PIPELINE_SOURCE == "web" && $CI_COMMIT_BRANCH =~ /^(master|production|preprod|development)$/'
    - if: '$CI_MERGE_REQUEST_ID || $CI_COMMIT_BRANCH =~ /^(master|production|preprod|development)$/'
      changes:
        - 'frontend-mono/**/*'
        - 'template.gitlab-ci.yml'
  cache:
    paths:
      - ./frontend-mono/node_modules/.cache
      - ./frontend-mono/apps/main/node_modules/.cache
      - ./frontend-mono/apps/my-pip/node_modules/.cache
      - ./frontend-mono/apps/mor/node_modules/.cache
      - ./frontend-mono/apps/vergadering/node_modules/.cache
      - ./frontend-mono/apps/external-components/node_modules/.cache
  before_script:
    - (if [ -z "$(ls -A /usr/local/share/.cache/yarn/v6)" ]; then echo "Empty cache folder /usr/local/share/.cache/yarn/v6, this will slow down the pipeline, ensure it is mounted by host machine"; fi)
    - cd frontend-mono
    - yarn --no-optional --ignore-engines
  script:
    - if [ $CI_PIPELINE_SOURCE == "merge_request_event" ]; then yarn run-all-ci && yarn audit-check; else echo "in else" && yarn run-all-ci-allow ; fi
  artifacts:
    paths:
      - frontend-mono/build/apps/
    reports:
      cyclonedx:
        - frontend-mono/cyclonedx.json
    expire_in: 1 day

# ------ Docker image jobs ------
.build_container_frontend:
  extends:
    - .frontend_job_variables
    - .build_and_push_container_image_template
  needs:
    - 'set-version-number-and-tag-commit'
    - 'frontend:Prepare App bundles'
  dependencies:
    - 'set-version-number-and-tag-commit'
    - 'frontend:Prepare App bundles'
  before_script:
    - echo "Add the project specific .dockerignore rules to the .dockerignore in the root"
    - cat frontend-mono/.dockerignore >> .dockerignore

frontend:Build container image (x86_64):
  extends: .build_container_frontend
  tags: ['xxllnc-shared', 'arch:x86_64']
  variables:
    BUILD_ARCH: 'amd64'

frontend:Build container image (arm64):
  extends: .build_container_frontend
  tags: ['xxllnc-shared', 'arch:arm64']
  variables:
    BUILD_ARCH: 'arm64'

frontend:Make multiarch manifest:
  extends:
    - .frontend_job_variables
    - .make_multiarch_manifest_template
  variables:
    BUILD_ARCHS: 'amd64 arm64'
  needs:
    - 'set-version-number-and-tag-commit'
    - 'frontend:Build container image (x86_64)'
    - 'frontend:Build container image (arm64)'

#
# Release targets
#
frontend:Tag xcp release container:
  extends:
    - .frontend_job_variables
    - .release_on_xcp
